require '_h2ph_pre.ph';

unless(defined(&BS_BAR)) {
    sub BS_BAR () {	0x10;}
}
unless(defined(&BS_MCR1)) {
    sub BS_MCR1 () {	0x00;}
}
unless(defined(&BS_CTRL)) {
    sub BS_CTRL () {	0x04;}
}
unless(defined(&BS_STAT)) {
    sub BS_STAT () {	0x08;}
}
unless(defined(&BS_ERR)) {
    sub BS_ERR () {	0x0c;}
}
unless(defined(&BS_MCR2)) {
    sub BS_MCR2 () {	0x10;}
}
unless(defined(&BS_CTRL_MCR2INT)) {
    sub BS_CTRL_MCR2INT () {	0x40000000;}
}
unless(defined(&BS_CTRL_MCR1INT)) {
    sub BS_CTRL_MCR1INT () {	0x20000000;}
}
unless(defined(&BS_CTRL_OFM)) {
    sub BS_CTRL_OFM () {	0x10000000;}
}
unless(defined(&BS_CTRL_BE32)) {
    sub BS_CTRL_BE32 () {	0x08000000;}
}
unless(defined(&BS_CTRL_BE64)) {
    sub BS_CTRL_BE64 () {	0x04000000;}
}
unless(defined(&BS_CTRL_DMAERR)) {
    sub BS_CTRL_DMAERR () {	0x02000000;}
}
unless(defined(&BS_CTRL_RNG_M)) {
    sub BS_CTRL_RNG_M () {	0x01800000;}
}
unless(defined(&BS_CTRL_RNG_1)) {
    sub BS_CTRL_RNG_1 () {	0x00000000;}
}
unless(defined(&BS_CTRL_RNG_4)) {
    sub BS_CTRL_RNG_4 () {	0x00800000;}
}
unless(defined(&BS_CTRL_RNG_8)) {
    sub BS_CTRL_RNG_8 () {	0x01000000;}
}
unless(defined(&BS_CTRL_RNG_16)) {
    sub BS_CTRL_RNG_16 () {	0x01800000;}
}
unless(defined(&BS_CTRL_FRAG_M)) {
    sub BS_CTRL_FRAG_M () {	0x0000ffff;}
}
unless(defined(&BS_STAT_MCR1_BUSY)) {
    sub BS_STAT_MCR1_BUSY () {	0x80000000;}
}
unless(defined(&BS_STAT_MCR1_FULL)) {
    sub BS_STAT_MCR1_FULL () {	0x40000000;}
}
unless(defined(&BS_STAT_MCR1_DONE)) {
    sub BS_STAT_MCR1_DONE () {	0x20000000;}
}
unless(defined(&BS_STAT_DMAERR)) {
    sub BS_STAT_DMAERR () {	0x10000000;}
}
unless(defined(&BS_STAT_MCR2_FULL)) {
    sub BS_STAT_MCR2_FULL () {	0x08000000;}
}
unless(defined(&BS_STAT_MCR2_DONE)) {
    sub BS_STAT_MCR2_DONE () {	0x04000000;}
}
unless(defined(&BS_ERR_ADDR)) {
    sub BS_ERR_ADDR () {	0xfffffffc;}
}
unless(defined(&BS_ERR_READ)) {
    sub BS_ERR_READ () {	0x00000002;}
}
unless(defined(&UBSEC_CARD)) {
    sub UBSEC_CARD {
	local($sid) = @_;
	eval q(((($sid) & 0xf0000000) >> 28));
    }
}
unless(defined(&UBSEC_SESSION)) {
    sub UBSEC_SESSION {
	local($sid) = @_;
	eval q(( ($sid) & 0x0fffffff));
    }
}
unless(defined(&UBSEC_SID)) {
    sub UBSEC_SID {
	local($crd, $sesn) = @_;
	eval q(((($crd) << 28) | (($sesn) & 0x0fffffff)));
    }
}
unless(defined(&MAX_SCATTER)) {
    sub MAX_SCATTER () {	64;}
}
unless(defined(&UBS_PKTCTX_ENC_3DES)) {
    sub UBS_PKTCTX_ENC_3DES () {	0x8000;}
}
unless(defined(&UBS_PKTCTX_ENC_NONE)) {
    sub UBS_PKTCTX_ENC_NONE () {	0x0000;}
}
unless(defined(&UBS_PKTCTX_INBOUND)) {
    sub UBS_PKTCTX_INBOUND () {	0x4000;}
}
unless(defined(&UBS_PKTCTX_AUTH)) {
    sub UBS_PKTCTX_AUTH () {	0x3000;}
}
unless(defined(&UBS_PKTCTX_AUTH_NONE)) {
    sub UBS_PKTCTX_AUTH_NONE () {	0x0000;}
}
unless(defined(&UBS_PKTCTX_AUTH_MD5)) {
    sub UBS_PKTCTX_AUTH_MD5 () {	0x1000;}
}
unless(defined(&UBS_PKTCTX_AUTH_SHA1)) {
    sub UBS_PKTCTX_AUTH_SHA1 () {	0x2000;}
}
unless(defined(&UBS_PKTBUF_LEN)) {
    sub UBS_PKTBUF_LEN () {	0x0000ffff;}
}
unless(defined(&UBS_MCR_DONE)) {
    sub UBS_MCR_DONE () {	0x0001;}
}
unless(defined(&UBS_MCR_ERROR)) {
    sub UBS_MCR_ERROR () {	0x0002;}
}
unless(defined(&UBS_MCR_ERRORCODE)) {
    sub UBS_MCR_ERRORCODE () {	0xff00;}
}
unless(defined(&UBS_CTXOP_DHPKGEN)) {
    sub UBS_CTXOP_DHPKGEN () {	0x01;}
}
unless(defined(&UBS_CTXOP_DHSSGEN)) {
    sub UBS_CTXOP_DHSSGEN () {	0x02;}
}
unless(defined(&UBS_CTXOP_RSAPUB)) {
    sub UBS_CTXOP_RSAPUB () {	0x03;}
}
unless(defined(&UBS_CTXOP_RSAPRIV)) {
    sub UBS_CTXOP_RSAPRIV () {	0x04;}
}
unless(defined(&UBS_CTXOP_DSASIGN)) {
    sub UBS_CTXOP_DSASIGN () {	0x05;}
}
unless(defined(&UBS_CTXOP_DSAVRFY)) {
    sub UBS_CTXOP_DSAVRFY () {	0x06;}
}
unless(defined(&UBS_CTXOP_RNGBYPASS)) {
    sub UBS_CTXOP_RNGBYPASS () {	0x41;}
}
unless(defined(&UBS_CTXOP_RNGSHA1)) {
    sub UBS_CTXOP_RNGSHA1 () {	0x42;}
}
unless(defined(&UBS_CTXOP_MODADD)) {
    sub UBS_CTXOP_MODADD () {	0x43;}
}
unless(defined(&UBS_CTXOP_MODSUB)) {
    sub UBS_CTXOP_MODSUB () {	0x44;}
}
unless(defined(&UBS_CTXOP_MODMUL)) {
    sub UBS_CTXOP_MODMUL () {	0x45;}
}
unless(defined(&UBS_CTXOP_MODRED)) {
    sub UBS_CTXOP_MODRED () {	0x46;}
}
unless(defined(&UBS_CTXOP_MODEXP)) {
    sub UBS_CTXOP_MODEXP () {	0x47;}
}
unless(defined(&UBS_CTXOP_MODINV)) {
    sub UBS_CTXOP_MODINV () {	0x48;}
}
unless(defined(&UBS_RNGBUFSZ)) {
    sub UBS_RNGBUFSZ () {	16;}
}
1;
