require '_h2ph_pre.ph';

unless(defined(&__IP_FIL_H__)) {
    eval 'sub __IP_FIL_H__ () {1;}' unless defined(&__IP_FIL_H__);
    eval 'sub IPNAT_NAME () {"/dev/ipnat";}' unless defined(&IPNAT_NAME);
    eval 'sub IPSTATE_NAME () {"/dev/ipstate";}' unless defined(&IPSTATE_NAME);
    eval 'sub IPAUTH_NAME () {"/dev/ipauth";}' unless defined(&IPAUTH_NAME);
    unless(defined(&SOLARIS)) {
	eval 'sub SOLARIS () {(defined( &sun)  && (defined( &__svr4__) || defined( &__SVR4)));}' unless defined(&SOLARIS);
    }
    if(defined( &KERNEL)  && !defined( &_KERNEL)) {
	eval 'sub _KERNEL () {1;}' unless defined(&_KERNEL);
    }
    unless(defined(&__P)) {
	if(defined(&__STDC__)) {
	    eval 'sub __P {
	        local($x) = @_;
    		eval q($x);
	    }' unless defined(&__P);
	} else {
	    eval 'sub __P {
	        local($x) = @_;
    		eval q(());
	    }' unless defined(&__P);
	}
    }
    if(defined( &__STDC__) || defined( &__GNUC__)) {
	eval 'sub SIOCADAFR () { &_IOW(ord(\'r\'), 60, \'struct frentry\' *);}' unless defined(&SIOCADAFR);
	eval 'sub SIOCRMAFR () { &_IOW(ord(\'r\'), 61, \'struct frentry\' *);}' unless defined(&SIOCRMAFR);
	eval 'sub SIOCSETFF () { &_IOW(ord(\'r\'), 62, \'u_int\');}' unless defined(&SIOCSETFF);
	eval 'sub SIOCGETFF () { &_IOR(ord(\'r\'), 63, \'u_int\');}' unless defined(&SIOCGETFF);
	eval 'sub SIOCGETFS () { &_IOWR(ord(\'r\'), 64, \'struct friostat\' *);}' unless defined(&SIOCGETFS);
	eval 'sub SIOCIPFFL () { &_IOWR(ord(\'r\'), 65, \'int\');}' unless defined(&SIOCIPFFL);
	eval 'sub SIOCIPFFB () { &_IOR(ord(\'r\'), 66, \'int\');}' unless defined(&SIOCIPFFB);
	eval 'sub SIOCADIFR () { &_IOW(ord(\'r\'), 67, \'struct frentry\' *);}' unless defined(&SIOCADIFR);
	eval 'sub SIOCRMIFR () { &_IOW(ord(\'r\'), 68, \'struct frentry\' *);}' unless defined(&SIOCRMIFR);
	eval 'sub SIOCSWAPA () { &_IOR(ord(\'r\'), 69, \'u_int\');}' unless defined(&SIOCSWAPA);
	eval 'sub SIOCINAFR () { &_IOW(ord(\'r\'), 70, \'struct frentry\' *);}' unless defined(&SIOCINAFR);
	eval 'sub SIOCINIFR () { &_IOW(ord(\'r\'), 71, \'struct frentry\' *);}' unless defined(&SIOCINIFR);
	eval 'sub SIOCFRENB () { &_IOW(ord(\'r\'), 72, \'u_int\');}' unless defined(&SIOCFRENB);
	eval 'sub SIOCFRSYN () { &_IOW(ord(\'r\'), 73, \'u_int\');}' unless defined(&SIOCFRSYN);
	eval 'sub SIOCFRZST () { &_IOWR(ord(\'r\'), 74, \'struct friostat\' *);}' unless defined(&SIOCFRZST);
	eval 'sub SIOCZRLST () { &_IOWR(ord(\'r\'), 75, \'struct frentry\' *);}' unless defined(&SIOCZRLST);
	eval 'sub SIOCAUTHW () { &_IOWR(ord(\'r\'), 76, \'struct fr_info\' *);}' unless defined(&SIOCAUTHW);
	eval 'sub SIOCAUTHR () { &_IOWR(ord(\'r\'), 77, \'struct fr_info\' *);}' unless defined(&SIOCAUTHR);
	eval 'sub SIOCATHST () { &_IOWR(ord(\'r\'), 78, \'struct fr_authstat\' *);}' unless defined(&SIOCATHST);
	eval 'sub SIOCSTLCK () { &_IOWR(ord(\'r\'), 79, \'u_int\');}' unless defined(&SIOCSTLCK);
	eval 'sub SIOCSTPUT () { &_IOWR(ord(\'r\'), 80, \'struct ipstate_save\' *);}' unless defined(&SIOCSTPUT);
	eval 'sub SIOCSTGET () { &_IOWR(ord(\'r\'), 81, \'struct ipstate_save\' *);}' unless defined(&SIOCSTGET);
	eval 'sub SIOCSTGSZ () { &_IOWR(ord(\'r\'), 82, \'struct natget\' *);}' unless defined(&SIOCSTGSZ);
	eval 'sub SIOCGFRST () { &_IOWR(ord(\'r\'), 83, \'struct ipfrstat\' *);}' unless defined(&SIOCGFRST);
    } else {
	eval 'sub SIOCADAFR () { &_IOW("r", 60, \'struct frentry\' *);}' unless defined(&SIOCADAFR);
	eval 'sub SIOCRMAFR () { &_IOW("r", 61, \'struct frentry\' *);}' unless defined(&SIOCRMAFR);
	eval 'sub SIOCSETFF () { &_IOW("r", 62, \'u_int\');}' unless defined(&SIOCSETFF);
	eval 'sub SIOCGETFF () { &_IOR("r", 63, \'u_int\');}' unless defined(&SIOCGETFF);
	eval 'sub SIOCGETFS () { &_IOWR("r", 64, \'struct friostat\' *);}' unless defined(&SIOCGETFS);
	eval 'sub SIOCIPFFL () { &_IOWR("r", 65, \'int\');}' unless defined(&SIOCIPFFL);
	eval 'sub SIOCIPFFB () { &_IOR("r", 66, \'int\');}' unless defined(&SIOCIPFFB);
	eval 'sub SIOCADIFR () { &_IOW("r", 67, \'struct frentry\' *);}' unless defined(&SIOCADIFR);
	eval 'sub SIOCRMIFR () { &_IOW("r", 68, \'struct frentry\' *);}' unless defined(&SIOCRMIFR);
	eval 'sub SIOCSWAPA () { &_IOR("r", 69, \'u_int\');}' unless defined(&SIOCSWAPA);
	eval 'sub SIOCINAFR () { &_IOW("r", 70, \'struct frentry\' *);}' unless defined(&SIOCINAFR);
	eval 'sub SIOCINIFR () { &_IOW("r", 71, \'struct frentry\' *);}' unless defined(&SIOCINIFR);
	eval 'sub SIOCFRENB () { &_IOW("r", 72, \'u_int\');}' unless defined(&SIOCFRENB);
	eval 'sub SIOCFRSYN () { &_IOW("r", 73, \'u_int\');}' unless defined(&SIOCFRSYN);
	eval 'sub SIOCFRZST () { &_IOWR("r", 74, \'struct friostat\' *);}' unless defined(&SIOCFRZST);
	eval 'sub SIOCZRLST () { &_IOWR("r", 75, \'struct frentry\' *);}' unless defined(&SIOCZRLST);
	eval 'sub SIOCAUTHW () { &_IOWR("r", 76, \'struct fr_info\' *);}' unless defined(&SIOCAUTHW);
	eval 'sub SIOCAUTHR () { &_IOWR("r", 77, \'struct fr_info\' *);}' unless defined(&SIOCAUTHR);
	eval 'sub SIOCATHST () { &_IOWR("r", 78, \'struct fr_authstat\' *);}' unless defined(&SIOCATHST);
	eval 'sub SIOCSTLCK () { &_IOWR("r", 79, \'u_int\');}' unless defined(&SIOCSTLCK);
	eval 'sub SIOCSTPUT () { &_IOWR("r", 80, \'struct ipstate_save\' *);}' unless defined(&SIOCSTPUT);
	eval 'sub SIOCSTGET () { &_IOWR("r", 81, \'struct ipstate_save\' *);}' unless defined(&SIOCSTGET);
	eval 'sub SIOCSTGSZ () { &_IOWR("r", 82, \'struct natget\' *);}' unless defined(&SIOCSTGSZ);
	eval 'sub SIOCGFRST () { &_IOWR("r", 83, \'struct ipfrstat\' *);}' unless defined(&SIOCGFRST);
    }
    eval 'sub SIOCADDFR () { &SIOCADAFR;}' unless defined(&SIOCADDFR);
    eval 'sub SIOCDELFR () { &SIOCRMAFR;}' unless defined(&SIOCDELFR);
    eval 'sub SIOCINSFR () { &SIOCINAFR;}' unless defined(&SIOCINSFR);
    eval 'sub FI_OPTIONS () {( &FF_OPTIONS >> 24);}' unless defined(&FI_OPTIONS);
    eval 'sub FI_TCPUDP () {( &FF_TCPUDP >> 24);}' unless defined(&FI_TCPUDP);
    eval 'sub FI_FRAG () {( &FF_FRAG >> 24);}' unless defined(&FI_FRAG);
    eval 'sub FI_SHORT () {( &FF_SHORT >> 24);}' unless defined(&FI_SHORT);
    eval 'sub FI_CMP () {( &FI_OPTIONS| &FI_TCPUDP| &FI_SHORT);}' unless defined(&FI_CMP);
    eval 'sub fi_saddr () { ($fi_src->{in4}->{s_addr});}' unless defined(&fi_saddr);
    eval 'sub fi_daddr () { ($fi_dst->{in4}->{s_addr});}' unless defined(&fi_daddr);
    eval 'sub FI_W_SPORT () {0x00000100;}' unless defined(&FI_W_SPORT);
    eval 'sub FI_W_DPORT () {0x00000200;}' unless defined(&FI_W_DPORT);
    eval 'sub FI_WILDP () {( &FI_W_SPORT| &FI_W_DPORT);}' unless defined(&FI_WILDP);
    eval 'sub FI_W_SADDR () {0x00000400;}' unless defined(&FI_W_SADDR);
    eval 'sub FI_W_DADDR () {0x00000800;}' unless defined(&FI_W_DADDR);
    eval 'sub FI_WILDA () {( &FI_W_SADDR| &FI_W_DADDR);}' unless defined(&FI_WILDA);
    eval 'sub FI_NEWFR () {0x00001000;}' unless defined(&FI_NEWFR);
    if((defined(&SOLARIS) ? &SOLARIS : 0)) {
    }
    eval 'sub fin_v () { ($fin_fi->{fi_v});}' unless defined(&fin_v);
    eval 'sub FI_CSIZE () { &offsetof( &fr_info_t,  &fin_icode);}' unless defined(&FI_CSIZE);
    eval 'sub FI_COPYSIZE () { &offsetof( &fr_info_t,  &fin_dp);}' unless defined(&FI_COPYSIZE);
    eval 'sub ftu_scmp () { ($ftu_src->{frp_cmp});}' unless defined(&ftu_scmp);
    eval 'sub ftu_dcmp () { ($ftu_dst->{frp_cmp});}' unless defined(&ftu_dcmp);
    eval 'sub ftu_sport () { ($ftu_src->{frp_port});}' unless defined(&ftu_sport);
    eval 'sub ftu_dport () { ($ftu_dst->{frp_port});}' unless defined(&ftu_dport);
    eval 'sub ftu_stop () { ($ftu_src->{frp_top});}' unless defined(&ftu_stop);
    eval 'sub ftu_dtop () { ($ftu_dst->{frp_top});}' unless defined(&ftu_dtop);
    if((defined(&BSD) ? &BSD : 0) >= 199306) {
    }
    if((defined(&BSD) ? &BSD : 0) >= 199306) {
    }
    eval 'sub fr_v () { ($fr_ip->{fi_v});}' unless defined(&fr_v);
    eval 'sub fr_proto () { ($fr_ip->{fi_p});}' unless defined(&fr_proto);
    eval 'sub fr_ttl () { ($fr_ip->{fi_ttl});}' unless defined(&fr_ttl);
    eval 'sub fr_tos () { ($fr_ip->{fi_tos});}' unless defined(&fr_tos);
    eval 'sub fr_tcpfm () { ($fr_tuc->{ftu_tcpfm});}' unless defined(&fr_tcpfm);
    eval 'sub fr_tcpf () { ($fr_tuc->{ftu_tcpf});}' unless defined(&fr_tcpf);
    eval 'sub fr_scmp () { ($fr_tuc->{ftu_scmp});}' unless defined(&fr_scmp);
    eval 'sub fr_dcmp () { ($fr_tuc->{ftu_dcmp});}' unless defined(&fr_dcmp);
    eval 'sub fr_dport () { ($fr_tuc->{ftu_dport});}' unless defined(&fr_dport);
    eval 'sub fr_sport () { ($fr_tuc->{ftu_sport});}' unless defined(&fr_sport);
    eval 'sub fr_stop () { ($fr_tuc->{ftu_stop});}' unless defined(&fr_stop);
    eval 'sub fr_dtop () { ($fr_tuc->{ftu_dtop});}' unless defined(&fr_dtop);
    eval 'sub fr_dst () { ($fr_ip->{fi_dst}->{in4});}' unless defined(&fr_dst);
    eval 'sub fr_src () { ($fr_ip->{fi_src}->{in4});}' unless defined(&fr_src);
    eval 'sub fr_dmsk () { ($fr_mip->{fi_dst}->{in4});}' unless defined(&fr_dmsk);
    eval 'sub fr_smsk () { ($fr_mip->{fi_src}->{in4});}' unless defined(&fr_smsk);
    unless(defined(&offsetof)) {
	eval 'sub offsetof {
	    local($t,$m) = @_;
    	    eval q((((0)->$m)));
	}' unless defined(&offsetof);
    }
    eval 'sub FR_CMPSIZ () {($sizeof{\'struct frentry\'} -  &offsetof( &frentry_t,  &fr_ip));}' unless defined(&FR_CMPSIZ);
    eval 'sub FR_BLOCK () {0x00001;}' unless defined(&FR_BLOCK);
    eval 'sub FR_PASS () {0x00002;}' unless defined(&FR_PASS);
    eval 'sub FR_OUTQUE () {0x00004;}' unless defined(&FR_OUTQUE);
    eval 'sub FR_INQUE () {0x00008;}' unless defined(&FR_INQUE);
    eval 'sub FR_LOG () {0x00010;}' unless defined(&FR_LOG);
    eval 'sub FR_LOGB () {0x00011;}' unless defined(&FR_LOGB);
    eval 'sub FR_LOGP () {0x00012;}' unless defined(&FR_LOGP);
    eval 'sub FR_LOGBODY () {0x00020;}' unless defined(&FR_LOGBODY);
    eval 'sub FR_LOGFIRST () {0x00040;}' unless defined(&FR_LOGFIRST);
    eval 'sub FR_RETRST () {0x00080;}' unless defined(&FR_RETRST);
    eval 'sub FR_RETICMP () {0x00100;}' unless defined(&FR_RETICMP);
    eval 'sub FR_FAKEICMP () {0x00180;}' unless defined(&FR_FAKEICMP);
    eval 'sub FR_NOMATCH () {0x00200;}' unless defined(&FR_NOMATCH);
    eval 'sub FR_ACCOUNT () {0x00400;}' unless defined(&FR_ACCOUNT);
    eval 'sub FR_KEEPFRAG () {0x00800;}' unless defined(&FR_KEEPFRAG);
    eval 'sub FR_KEEPSTATE () {0x01000;}' unless defined(&FR_KEEPSTATE);
    eval 'sub FR_INACTIVE () {0x02000;}' unless defined(&FR_INACTIVE);
    eval 'sub FR_QUICK () {0x04000;}' unless defined(&FR_QUICK);
    eval 'sub FR_FASTROUTE () {0x08000;}' unless defined(&FR_FASTROUTE);
    eval 'sub FR_CALLNOW () {0x10000;}' unless defined(&FR_CALLNOW);
    eval 'sub FR_DUP () {0x20000;}' unless defined(&FR_DUP);
    eval 'sub FR_LOGORBLOCK () {0x40000;}' unless defined(&FR_LOGORBLOCK);
    eval 'sub FR_NOTSRCIP () {0x80000;}' unless defined(&FR_NOTSRCIP);
    eval 'sub FR_NOTDSTIP () {0x100000;}' unless defined(&FR_NOTDSTIP);
    eval 'sub FR_AUTH () {0x200000;}' unless defined(&FR_AUTH);
    eval 'sub FR_PREAUTH () {0x400000;}' unless defined(&FR_PREAUTH);
    eval 'sub FR_DONTCACHE () {0x800000;}' unless defined(&FR_DONTCACHE);
    eval 'sub FR_LOGMASK () {( &FR_LOG| &FR_LOGP| &FR_LOGB);}' unless defined(&FR_LOGMASK);
    eval 'sub FR_RETMASK () {( &FR_RETICMP| &FR_RETRST| &FR_FAKEICMP);}' unless defined(&FR_RETMASK);
    eval 'sub FF_OPTIONS () {0x01000000;}' unless defined(&FF_OPTIONS);
    eval 'sub FF_TCPUDP () {0x02000000;}' unless defined(&FF_TCPUDP);
    eval 'sub FF_FRAG () {0x04000000;}' unless defined(&FF_FRAG);
    eval 'sub FF_SHORT () {0x08000000;}' unless defined(&FF_SHORT);
    eval 'sub FF_LOGPASS () {0x10000000;}' unless defined(&FF_LOGPASS);
    eval 'sub FF_LOGBLOCK () {0x20000000;}' unless defined(&FF_LOGBLOCK);
    eval 'sub FF_LOGNOMATCH () {0x40000000;}' unless defined(&FF_LOGNOMATCH);
    eval 'sub FF_LOGGING () {( &FF_LOGPASS| &FF_LOGBLOCK| &FF_LOGNOMATCH);}' unless defined(&FF_LOGGING);
    eval 'sub FF_BLOCKNONIP () {0x80000000;}' unless defined(&FF_BLOCKNONIP);
    eval 'sub FR_NONE () {0;}' unless defined(&FR_NONE);
    eval 'sub FR_EQUAL () {1;}' unless defined(&FR_EQUAL);
    eval 'sub FR_NEQUAL () {2;}' unless defined(&FR_NEQUAL);
    eval 'sub FR_LESST () {3;}' unless defined(&FR_LESST);
    eval 'sub FR_GREATERT () {4;}' unless defined(&FR_GREATERT);
    eval 'sub FR_LESSTE () {5;}' unless defined(&FR_LESSTE);
    eval 'sub FR_GREATERTE () {6;}' unless defined(&FR_GREATERTE);
    eval 'sub FR_OUTRANGE () {7;}' unless defined(&FR_OUTRANGE);
    eval 'sub FR_INRANGE () {8;}' unless defined(&FR_INRANGE);
    if((defined(&SOLARIS) ? &SOLARIS : 0)) {
    }
    eval 'sub IPL_MAGIC () {0x49504c4d;}' unless defined(&IPL_MAGIC);
    if((defined( &NetBSD)  && ((defined(&NetBSD) ? &NetBSD : 0) <= 1991011)  && ((defined(&NetBSD) ? &NetBSD : 0) >= 199603)) || (defined( &OpenBSD)  && ((defined(&OpenBSD) ? &OpenBSD : 0) >= 199603))) {
    } else {
    }
    unless(defined(&ICMP_UNREACH_FILTER)) {
	eval 'sub ICMP_UNREACH_FILTER () {13;}' unless defined(&ICMP_UNREACH_FILTER);
    }
    unless(defined(&IPF_LOGGING)) {
	eval 'sub IPF_LOGGING () {0;}' unless defined(&IPF_LOGGING);
    }
    unless(defined(&IPF_DEFAULT_PASS)) {
	eval 'sub IPF_DEFAULT_PASS () { &FR_PASS;}' unless defined(&IPF_DEFAULT_PASS);
    }
    eval 'sub IPMINLEN {
        local($i, $h) = @_;
	    eval q((($i)-> &ip_len >= (($i)-> &ip_hl * 4+ $sizeof{\'struct h\'})));
    }' unless defined(&IPMINLEN);
    eval 'sub IPLLOGSIZE () {8192;}' unless defined(&IPLLOGSIZE);
    unless(defined(&IPL_NAME)) {
	if((defined(&SOLARIS) ? &SOLARIS : 0)) {
	    eval 'sub IPL_NAME () {"/dev/ipf";}' unless defined(&IPL_NAME);
	} else {
	    eval 'sub IPL_NAME () {"/dev/ipl";}' unless defined(&IPL_NAME);
	}
    }
    eval 'sub IPL_NAT () { &IPNAT_NAME;}' unless defined(&IPL_NAT);
    eval 'sub IPL_STATE () { &IPSTATE_NAME;}' unless defined(&IPL_STATE);
    eval 'sub IPL_AUTH () { &IPAUTH_NAME;}' unless defined(&IPL_AUTH);
    eval 'sub IPL_LOGIPF () {0;}' unless defined(&IPL_LOGIPF);
    eval 'sub IPL_LOGNAT () {1;}' unless defined(&IPL_LOGNAT);
    eval 'sub IPL_LOGSTATE () {2;}' unless defined(&IPL_LOGSTATE);
    eval 'sub IPL_LOGAUTH () {3;}' unless defined(&IPL_LOGAUTH);
    eval 'sub IPL_LOGMAX () {3;}' unless defined(&IPL_LOGMAX);
    if(!defined( &CDEV_MAJOR)  && defined ( &__FreeBSD_version)  && ((defined(&__FreeBSD_version) ? &__FreeBSD_version : 0) >= 220000)) {
	eval 'sub CDEV_MAJOR () {79;}' unless defined(&CDEV_MAJOR);
    }
    if((defined( &NetBSD)  && ((defined(&NetBSD) ? &NetBSD : 0) > 199609)  && ((defined(&NetBSD) ? &NetBSD : 0) <= 1991011)) || (defined( &NetBSD1_2)  && (defined(&NetBSD1_2) ? &NetBSD1_2 : 0) > 1)) {
	if(((defined(&NetBSD) ? &NetBSD : 0) >= 199905)) {
	    eval 'sub PFIL_HOOKS () {1;}' unless defined(&PFIL_HOOKS);
	}
	if(defined(&PFIL_HOOKS)) {
	    eval 'sub NETBSD_PF () {1;}' unless defined(&NETBSD_PF);
	}
    }
    unless(defined(&_KERNEL)) {
	if(defined( &__NetBSD__) || defined( &__OpenBSD__) || ((defined(&_BSDI_VERSION) ? &_BSDI_VERSION : 0) >= 199701) || ((defined(&__FreeBSD_version) ? &__FreeBSD_version : 0) >= 300000)) {
	} else {
	}
    } else {
	if(defined( &__NetBSD__)  && defined( &PFIL_HOOKS)) {
	}
	if((defined(&SOLARIS) ? &SOLARIS : 0)) {
	    if((defined(&SOLARIS2) ? &SOLARIS2 : 0) >= 7) {
	    } else {
	    }
	} else {
	    if(defined(&__sgi)) {
		require 'sys/cred.ph';
	    } else {
		if(defined(&IPFILTER_LKM)) {
		}
		if(((defined(&_BSDI_VERSION) ? &_BSDI_VERSION : 0) >= 199510) || ((defined(&__FreeBSD_version) ? &__FreeBSD_version : 0) >= 220000) || ((defined(&NetBSD) ? &NetBSD : 0) >= 199511) || defined( &__OpenBSD__)) {
		    if(defined( &__NetBSD__) || ((defined(&_BSDI_VERSION) ? &_BSDI_VERSION : 0) >= 199701) || defined( &__OpenBSD__) || ((defined(&__FreeBSD_version) ? &__FreeBSD_version : 0) >= 300000)) {
		    } else {
		    }
		} else {
		    unless(defined(&linux)) {
		    } else {
		    }
		}
		if((defined(&BSD) ? &BSD : 0) >= 199306) {
		} else {
		    unless(defined(&linux)) {
		    } else {
		    }
		}
	    }
	}
    }
    if(defined(&USE_INET6)) {
    }
}
1;
