require '_h2ph_pre.ph';

unless(defined(&_MACHINE_PMAP_H_)) {
    eval 'sub _MACHINE_PMAP_H_ () {1;}' unless defined(&_MACHINE_PMAP_H_);
    require 'machine/pte.ph';
    unless(defined(&_LOCORE)) {
    }
    eval 'sub SR_TYPE () {0x80000000;}' unless defined(&SR_TYPE);
    eval 'sub SR_SUKEY () {0x40000000;}' unless defined(&SR_SUKEY);
    eval 'sub SR_PRKEY () {0x20000000;}' unless defined(&SR_PRKEY);
    eval 'sub SR_VSID () {0x00ffffff;}' unless defined(&SR_VSID);
    unless(defined(&_LOCORE)) {
	eval 'sub VP_SR_SIZE () {32;}' unless defined(&VP_SR_SIZE);
	eval 'sub VP_SR_MASK () { &VP_SR_SIZE-1;}' unless defined(&VP_SR_MASK);
	eval 'sub VP_SR_POS () {27;}' unless defined(&VP_SR_POS);
	eval 'sub VP_IDX1_SIZE () {1024;}' unless defined(&VP_IDX1_SIZE);
	eval 'sub VP_IDX1_MASK () { &VP_IDX1_SIZE-1;}' unless defined(&VP_IDX1_MASK);
	eval 'sub VP_IDX1_POS () {17;}' unless defined(&VP_IDX1_POS);
	eval 'sub VP_IDX2_SIZE () {32;}' unless defined(&VP_IDX2_SIZE);
	eval 'sub VP_IDX2_MASK () { &VP_IDX2_SIZE-1;}' unless defined(&VP_IDX2_MASK);
	eval 'sub VP_IDX2_POS () {12;}' unless defined(&VP_IDX2_POS);
	if(defined(&_KERNEL)) {
	    eval 'sub pmap_kernel () {
	        eval q(( &kernel_pmap_));
	    }' unless defined(&pmap_kernel);
	    eval 'sub pmap_clear_modify {
	        local($pa) = @_;
    		eval q(( &ptemodify(($pa),  &PTE_CHG, 0)));
	    }' unless defined(&pmap_clear_modify);
	    eval 'sub pmap_clear_reference {
	        local($pa) = @_;
    		eval q(( &ptemodify(($pa),  &PTE_REF, 0)));
	    }' unless defined(&pmap_clear_reference);
	    eval 'sub pmap_is_modified {
	        local($pa) = @_;
    		eval q(( &ptebits(($pa),  &PTE_CHG)));
	    }' unless defined(&pmap_is_modified);
	    eval 'sub pmap_is_referenced {
	        local($pa) = @_;
    		eval q(( &ptebits(($pa),  &PTE_REF)));
	    }' unless defined(&pmap_is_referenced);
	    eval 'sub pmap_change_wiring {
	        local($pm, $va, $wired) = @_;
    		eval q();
	    }' unless defined(&pmap_change_wiring);
	    eval 'sub pmap_phys_address {
	        local($x) = @_;
    		eval q(($x));
	    }' unless defined(&pmap_phys_address);
	    eval 'sub pmap_resident_count {
	        local($pmap) = @_;
    		eval q((($pmap)-> ($pm_stats->{resident_count})));
	    }' unless defined(&pmap_resident_count);
	}
    }
}
1;
