require '_h2ph_pre.ph';

unless(defined(&MACHINE_VMPARAM_H)) {
    eval 'sub MACHINE_VMPARAM_H () {1;}' unless defined(&MACHINE_VMPARAM_H);
    eval 'sub USRTEXT () { &CLBYTES;}' unless defined(&USRTEXT);
    eval 'sub USRSTACK () { &VM_MAXUSER_ADDRESS;}' unless defined(&USRSTACK);
    unless(defined(&MAXTSIZ)) {
	eval 'sub MAXTSIZ () {(16*1024*1024);}' unless defined(&MAXTSIZ);
    }
    unless(defined(&DFLDSIZ)) {
	eval 'sub DFLDSIZ () {(32*1024*1024);}' unless defined(&DFLDSIZ);
    }
    unless(defined(&MAXDSIZ)) {
	eval 'sub MAXDSIZ () {(512*1024*1024);}' unless defined(&MAXDSIZ);
    }
    unless(defined(&DFLSSIZ)) {
	eval 'sub DFLSSIZ () {(1*1024*1024);}' unless defined(&DFLSSIZ);
    }
    unless(defined(&MAXSSIZ)) {
	eval 'sub MAXSSIZ () {(32*1024*1024);}' unless defined(&MAXSSIZ);
    }
    eval 'sub DMMIN () {32;}' unless defined(&DMMIN);
    eval 'sub DMMAX () {4096;}' unless defined(&DMMAX);
    unless(defined(&SHMMAXPGS)) {
	eval 'sub SHMMAXPGS () {1024;}' unless defined(&SHMMAXPGS);
    }
    eval 'sub USRIOSIZE () {1024;}' unless defined(&USRIOSIZE);
    eval 'sub MAXSLP () {20;}' unless defined(&MAXSLP);
    eval 'sub VM_MIN_ADDRESS () {(0);}' unless defined(&VM_MIN_ADDRESS);
    eval 'sub VM_MAXUSER_ADDRESS () {(0xfffff000);}' unless defined(&VM_MAXUSER_ADDRESS);
    eval 'sub VM_MAX_ADDRESS () { &VM_MAXUSER_ADDRESS;}' unless defined(&VM_MAX_ADDRESS);
    eval 'sub VM_MIN_KERNEL_ADDRESS () {(( &KERNEL_SR <<  &ADDR_SR_SHFT));}' unless defined(&VM_MIN_KERNEL_ADDRESS);
    eval 'sub VM_KERN_ADDR_SIZE_DEF () { &SEGMENT_LENGTH;}' unless defined(&VM_KERN_ADDR_SIZE_DEF);
    eval 'sub VM_KERN_ADDRESS_SIZE () {( &ppc_kvm_size);}' unless defined(&VM_KERN_ADDRESS_SIZE);
    eval 'sub VM_MAX_KERNEL_ADDRESS () {((( &KERNEL_SR <<  &ADDR_SR_SHFT) +  &VM_KERN_ADDRESS_SIZE));}' unless defined(&VM_MAX_KERNEL_ADDRESS);
    eval 'sub MACHINE_NEW_NONCONTIG () {1;}' unless defined(&MACHINE_NEW_NONCONTIG);
    eval 'sub VM_KMEM_SIZE () {( &NKMEMCLUSTERS *  &CLBYTES);}' unless defined(&VM_KMEM_SIZE);
    eval 'sub VM_MBUF_SIZE () {( &NMBCLUSTERS *  &CLBYTES);}' unless defined(&VM_MBUF_SIZE);
    eval 'sub VM_PHYS_SIZE () {( &USRIOSIZE *  &CLBYTES);}' unless defined(&VM_PHYS_SIZE);
    eval 'sub VM_PHYSSEG_MAX () {32;}' unless defined(&VM_PHYSSEG_MAX);
    eval 'sub VM_PHYSSEG_STRAT () { &VM_PSTRAT_BSEARCH;}' unless defined(&VM_PHYSSEG_STRAT);
    eval 'sub VM_PHYSSEG_NOADD () {1;}' unless defined(&VM_PHYSSEG_NOADD);
    eval 'sub VM_NFREELIST () {1;}' unless defined(&VM_NFREELIST);
    eval 'sub VM_FREELIST_DEFAULT () {0;}' unless defined(&VM_FREELIST_DEFAULT);
}
1;
